/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: DPLVariable.java,v 1.10 2009-05-05 15:46:22 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.common.datapool;

import org.eclipse.emf.common.util.EList;
import org.eclipse.hyades.edit.datapool.IDatapoolVariable;
import org.eclipse.hyades.models.common.common.CMNNamedElement;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>DPL Variable</b></em>'.
 * @extends IDatapoolVariable
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.common.datapool.DPLVariable#getType <em>Type</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.datapool.DPLVariable#getRole <em>Role</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.datapool.DPLVariable#isEncrypted <em>Encrypted</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.common.datapool.DPLVariable#getVariables <em>Variables</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.models.common.datapool.Common_DatapoolPackage#getDPLVariable()
 * @model
 * @generated
 */
public interface DPLVariable extends CMNNamedElement, IDatapoolVariable {
	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see #setType(String)
	 * @see org.eclipse.hyades.models.common.datapool.Common_DatapoolPackage#getDPLVariable_Type()
	 * @model
	 * @generated
	 */
	String getType();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.datapool.DPLVariable#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see #getType()
	 * @generated
	 */
	void setType(String value);

	/**
	 * Returns the value of the '<em><b>Role</b></em>' attribute.
	 * The literals are from the enumeration {@link org.eclipse.hyades.models.common.datapool.DPLRole}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Role</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Role</em>' attribute.
	 * @see org.eclipse.hyades.models.common.datapool.DPLRole
	 * @see #setRole(DPLRole)
	 * @see org.eclipse.hyades.models.common.datapool.Common_DatapoolPackage#getDPLVariable_Role()
	 * @model
	 * @generated
	 */
	DPLRole getRole();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.datapool.DPLVariable#getRole <em>Role</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Role</em>' attribute.
	 * @see org.eclipse.hyades.models.common.datapool.DPLRole
	 * @see #getRole()
	 * @generated
	 */
	void setRole(DPLRole value);

	/**
	 * Returns the value of the '<em><b>Encrypted</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * This boolean specifies whether or not this DPLVariable is encrypted.
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Encrypted</em>' attribute.
	 * @see #setEncrypted(boolean)
	 * @see org.eclipse.hyades.models.common.datapool.Common_DatapoolPackage#getDPLVariable_Encrypted()
	 * @model default="false"
	 * @generated
	 */
	boolean isEncrypted();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.models.common.datapool.DPLVariable#isEncrypted <em>Encrypted</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * This boolean specifies whether or not this DPLVariable is encrypted.
	 * </p>
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Encrypted</em>' attribute.
	 * @see #isEncrypted()
	 * @generated
	 */
	void setEncrypted(boolean value);

	/**
	 * Returns the value of the '<em><b>Variables</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.hyades.models.common.datapool.DPLVariable}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Variables</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Variables</em>' containment reference list.
	 * @see org.eclipse.hyades.models.common.datapool.Common_DatapoolPackage#getDPLVariable_Variables()
	 * @model containment="true"
	 * @generated
	 */
	EList<DPLVariable> getVariables();

	
} // DPLVariable
