/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: Common_Behavior_InteractionsFactoryImpl.java,v 1.10 2009-05-05 15:49:18 paules Exp $
 **********************************************************************/
 
/*
 * generated using TPTP customized JET templates
 */

package org.eclipse.hyades.models.common.interactions.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.impl.EFactoryImpl;
import org.eclipse.emf.ecore.plugin.EcorePlugin;
import org.eclipse.hyades.models.common.interactions.BVREventOccurrence;
import org.eclipse.hyades.models.common.interactions.BVRExecutionOccurrence;
import org.eclipse.hyades.models.common.interactions.BVRGeneralOrdering;
import org.eclipse.hyades.models.common.interactions.BVRLifeline;
import org.eclipse.hyades.models.common.interactions.BVRMessage;
import org.eclipse.hyades.models.common.interactions.BVRMessageEnd;
import org.eclipse.hyades.models.common.interactions.BVRMessageSort;
import org.eclipse.hyades.models.common.interactions.BVRProperty;
import org.eclipse.hyades.models.common.interactions.BVRStateInvariant;
import org.eclipse.hyades.models.common.interactions.BVRStop;
import org.eclipse.hyades.models.common.interactions.Common_Behavior_InteractionsFactory;
import org.eclipse.hyades.models.common.interactions.Common_Behavior_InteractionsPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class Common_Behavior_InteractionsFactoryImpl extends EFactoryImpl implements Common_Behavior_InteractionsFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static Common_Behavior_InteractionsFactory init() {
		try {
			Common_Behavior_InteractionsFactory theCommon_Behavior_InteractionsFactory = (Common_Behavior_InteractionsFactory)EPackage.Registry.INSTANCE.getEFactory("http://www.eclipse.org/hyades/models/common/behavior/interactions.xmi"); 
			if (theCommon_Behavior_InteractionsFactory != null) {
				return theCommon_Behavior_InteractionsFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new Common_Behavior_InteractionsFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Common_Behavior_InteractionsFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case Common_Behavior_InteractionsPackage.BVR_LIFELINE: return createBVRLifeline();
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE: return createBVRMessage();
			case Common_Behavior_InteractionsPackage.BVR_GENERAL_ORDERING: return createBVRGeneralOrdering();
			case Common_Behavior_InteractionsPackage.BVR_EVENT_OCCURRENCE: return createBVREventOccurrence();
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE_END: return createBVRMessageEnd();
			case Common_Behavior_InteractionsPackage.BVR_EXECUTION_OCCURRENCE: return createBVRExecutionOccurrence();
			case Common_Behavior_InteractionsPackage.BVR_STATE_INVARIANT: return createBVRStateInvariant();
			case Common_Behavior_InteractionsPackage.BVR_STOP: return createBVRStop();
			case Common_Behavior_InteractionsPackage.BVR_PROPERTY: return createBVRProperty();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE_SORT:
				return createBVRMessageSortFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case Common_Behavior_InteractionsPackage.BVR_MESSAGE_SORT:
				return convertBVRMessageSortToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRLifeline createBVRLifeline() {
		BVRLifelineImpl bvrLifeline = new BVRLifelineImpl();
		return bvrLifeline;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRMessage createBVRMessage() {
		BVRMessageImpl bvrMessage = new BVRMessageImpl();
		return bvrMessage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRGeneralOrdering createBVRGeneralOrdering() {
		BVRGeneralOrderingImpl bvrGeneralOrdering = new BVRGeneralOrderingImpl();
		return bvrGeneralOrdering;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVREventOccurrence createBVREventOccurrence() {
		BVREventOccurrenceImpl bvrEventOccurrence = new BVREventOccurrenceImpl();
		return bvrEventOccurrence;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRMessageEnd createBVRMessageEnd() {
		BVRMessageEndImpl bvrMessageEnd = new BVRMessageEndImpl();
		return bvrMessageEnd;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRExecutionOccurrence createBVRExecutionOccurrence() {
		BVRExecutionOccurrenceImpl bvrExecutionOccurrence = new BVRExecutionOccurrenceImpl();
		return bvrExecutionOccurrence;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRStateInvariant createBVRStateInvariant() {
		BVRStateInvariantImpl bvrStateInvariant = new BVRStateInvariantImpl();
		return bvrStateInvariant;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRStop createBVRStop() {
		BVRStopImpl bvrStop = new BVRStopImpl();
		return bvrStop;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRProperty createBVRProperty() {
		BVRPropertyImpl bvrProperty = new BVRPropertyImpl();
		return bvrProperty;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BVRMessageSort createBVRMessageSortFromString(EDataType eDataType, String initialValue) {
		BVRMessageSort result = BVRMessageSort.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertBVRMessageSortToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Common_Behavior_InteractionsPackage getCommon_Behavior_InteractionsPackage() {
		return (Common_Behavior_InteractionsPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static Common_Behavior_InteractionsPackage getPackage() {
		return Common_Behavior_InteractionsPackage.eINSTANCE;
	}

} //Common_Behavior_InteractionsFactoryImpl
