/**********************************************************************
 * Copyright (c) 2003, 2009 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: CorrelationContainerImpl.java,v 1.3 2009-05-05 15:45:26 paules Exp $
 **********************************************************************/

/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.hierarchy.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.EMap;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EcoreEMap;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.hyades.models.hierarchy.CorrelationContainer;
import org.eclipse.hyades.models.hierarchy.CorrelationContainerProxy;
import org.eclipse.hyades.models.hierarchy.HierarchyPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Correlation Container</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.hyades.models.hierarchy.impl.CorrelationContainerImpl#getCorrelations <em>Correlations</em>}</li>
 *   <li>{@link org.eclipse.hyades.models.hierarchy.impl.CorrelationContainerImpl#getCorrelationContainerProxy <em>Correlation Container Proxy</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class CorrelationContainerImpl extends EObjectImpl implements CorrelationContainer {
	/**
	 * The cached value of the '{@link #getCorrelations() <em>Correlations</em>}' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCorrelations()
	 * @generated
	 * @ordered
	 */
	protected EMap<EObject, EList<EObject>> correlations;

	/**
	 * The cached value of the '{@link #getCorrelationContainerProxy() <em>Correlation Container Proxy</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCorrelationContainerProxy()
	 * @generated
	 * @ordered
	 */
	protected CorrelationContainerProxy correlationContainerProxy;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CorrelationContainerImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return HierarchyPackage.Literals.CORRELATION_CONTAINER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EMap<EObject, EList<EObject>> getCorrelations() {
		if (correlations == null) {
			correlations = new EcoreEMap<EObject,EList<EObject>>(HierarchyPackage.Literals.CORRELATION_ENTRY, CorrelationEntryImpl.class, this, HierarchyPackage.CORRELATION_CONTAINER__CORRELATIONS);
		}
		return correlations;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CorrelationContainerProxy getCorrelationContainerProxy() {
		if (correlationContainerProxy != null && correlationContainerProxy.eIsProxy()) {
			InternalEObject oldCorrelationContainerProxy = (InternalEObject)correlationContainerProxy;
			correlationContainerProxy = (CorrelationContainerProxy)eResolveProxy(oldCorrelationContainerProxy);
			if (correlationContainerProxy != oldCorrelationContainerProxy) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, HierarchyPackage.CORRELATION_CONTAINER__CORRELATION_CONTAINER_PROXY, oldCorrelationContainerProxy, correlationContainerProxy));
			}
		}
		return correlationContainerProxy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CorrelationContainerProxy basicGetCorrelationContainerProxy() {
		return correlationContainerProxy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetCorrelationContainerProxy(CorrelationContainerProxy newCorrelationContainerProxy, NotificationChain msgs) {
		CorrelationContainerProxy oldCorrelationContainerProxy = correlationContainerProxy;
		correlationContainerProxy = newCorrelationContainerProxy;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, HierarchyPackage.CORRELATION_CONTAINER__CORRELATION_CONTAINER_PROXY, oldCorrelationContainerProxy, newCorrelationContainerProxy);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCorrelationContainerProxy(CorrelationContainerProxy newCorrelationContainerProxy) {
		if (newCorrelationContainerProxy != correlationContainerProxy) {
			NotificationChain msgs = null;
			if (correlationContainerProxy != null)
				msgs = ((InternalEObject)correlationContainerProxy).eInverseRemove(this, HierarchyPackage.CORRELATION_CONTAINER_PROXY__CORRELATION_CONTAINER, CorrelationContainerProxy.class, msgs);
			if (newCorrelationContainerProxy != null)
				msgs = ((InternalEObject)newCorrelationContainerProxy).eInverseAdd(this, HierarchyPackage.CORRELATION_CONTAINER_PROXY__CORRELATION_CONTAINER, CorrelationContainerProxy.class, msgs);
			msgs = basicSetCorrelationContainerProxy(newCorrelationContainerProxy, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, HierarchyPackage.CORRELATION_CONTAINER__CORRELATION_CONTAINER_PROXY, newCorrelationContainerProxy, newCorrelationContainerProxy));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
		@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case HierarchyPackage.CORRELATION_CONTAINER__CORRELATIONS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getCorrelations()).basicAdd(otherEnd, msgs);
			case HierarchyPackage.CORRELATION_CONTAINER__CORRELATION_CONTAINER_PROXY:
				if (correlationContainerProxy != null)
					msgs = ((InternalEObject)correlationContainerProxy).eInverseRemove(this, HierarchyPackage.CORRELATION_CONTAINER_PROXY__CORRELATION_CONTAINER, CorrelationContainerProxy.class, msgs);
				return basicSetCorrelationContainerProxy((CorrelationContainerProxy)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case HierarchyPackage.CORRELATION_CONTAINER__CORRELATIONS:
				return ((InternalEList<?>)getCorrelations()).basicRemove(otherEnd, msgs);
			case HierarchyPackage.CORRELATION_CONTAINER__CORRELATION_CONTAINER_PROXY:
				return basicSetCorrelationContainerProxy(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case HierarchyPackage.CORRELATION_CONTAINER__CORRELATIONS:
				if (coreType) return getCorrelations();
				else return getCorrelations().map();
			case HierarchyPackage.CORRELATION_CONTAINER__CORRELATION_CONTAINER_PROXY:
				if (resolve) return getCorrelationContainerProxy();
				return basicGetCorrelationContainerProxy();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case HierarchyPackage.CORRELATION_CONTAINER__CORRELATIONS:
				((EStructuralFeature.Setting)getCorrelations()).set(newValue);
				return;
			case HierarchyPackage.CORRELATION_CONTAINER__CORRELATION_CONTAINER_PROXY:
				setCorrelationContainerProxy((CorrelationContainerProxy)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case HierarchyPackage.CORRELATION_CONTAINER__CORRELATIONS:
				getCorrelations().clear();
				return;
			case HierarchyPackage.CORRELATION_CONTAINER__CORRELATION_CONTAINER_PROXY:
				setCorrelationContainerProxy((CorrelationContainerProxy)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case HierarchyPackage.CORRELATION_CONTAINER__CORRELATIONS:
				return correlations != null && !correlations.isEmpty();
			case HierarchyPackage.CORRELATION_CONTAINER__CORRELATION_CONTAINER_PROXY:
				return correlationContainerProxy != null;
		}
		return super.eIsSet(featureID);
	}

} //CorrelationContainerImpl
