/*******************************************************************************
 * Copyright (c) 2011 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: 
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/

package org.eclipse.hyades.trace.ui.internal.export;

import java.io.IOException;
import java.io.OutputStream;
import java.math.BigDecimal;

import org.eclipse.hyades.models.hierarchy.TRCAgentProxy;
import org.eclipse.hyades.models.hierarchy.TRCFilter;
import org.eclipse.hyades.models.hierarchy.TRCNode;
import org.eclipse.hyades.models.hierarchy.TRCOption;
import org.eclipse.hyades.models.trace.TRCAggregatedMethodInvocation;
import org.eclipse.hyades.models.trace.TRCClass;
import org.eclipse.hyades.models.trace.TRCFullMethodInvocation;
import org.eclipse.hyades.models.trace.TRCFullTraceObject;
import org.eclipse.hyades.models.trace.TRCGCEvent;
import org.eclipse.hyades.models.trace.TRCMethod;
import org.eclipse.hyades.models.trace.TRCProcess;
import org.eclipse.hyades.models.trace.TRCThreadDeadEvent;
import org.eclipse.hyades.models.trace.TRCThreadRunningEvent;

public interface ITraceElementOutput {

	public abstract void output(OutputStream os, TRCThreadRunningEvent e) throws IOException;

	public abstract void output(OutputStream os, TRCThreadDeadEvent e) throws IOException;

	public abstract void output(OutputStream os, TRCFullMethodInvocation e, double s, BigDecimal bd, boolean isEntry) throws IOException;

	public abstract void output(OutputStream os, TRCAggregatedMethodInvocation e, boolean isEntry) throws IOException;

	public abstract void output(OutputStream os, TRCFilter f) throws IOException;

	public abstract void output(OutputStream os, TRCOption o) throws IOException;

	public abstract void output(OutputStream os, TRCMethod m) throws IOException;

	public abstract void output(OutputStream os, TRCGCEvent e) throws IOException;

	public abstract void output(OutputStream os, TRCFullTraceObject o, boolean isAlloc) throws IOException;

	public abstract void outputClassDef(TRCClass c, TRCProcess process, OutputStream os) throws IOException;

	public abstract void outputTraceEndTags(TRCProcess process, BigDecimal s, OutputStream os) throws IOException;

	public abstract void outputTraceStartTags(OutputStream out, TRCProcess process, TRCAgentProxy ap) throws IOException;

	public abstract void outputRuntimeInit(OutputStream os, TRCNode node, TRCProcess process) throws IOException;
}