/**********************************************************************
 * Copyright (c) 2006, 2011 IBM Corporation, Intel Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.tptp.platform.jvmti.client.internal;

import org.eclipse.osgi.util.NLS;

public class TIMessages
{
	private static final String BUNDLE_NAME = "org.eclipse.tptp.platform.jvmti.client.internal.messages";//$NON-NLS-1$
	
	private TIMessages() {
		// Do not instantiate
	}
	
	public static String ERROR_TI_AC_UNAVAILABLE;
	public static String ERROR_TI_AC_NOT_CONNECTED;
	public static String ERROR_TI_AC_UNKNOWN_HOST;
	public static String ERROR_TI_AC_UNKNOWN;
	
	public static String ERROR_TI_AGENT_UNAVAILABLE;
	public static String ERROR_TI_AGENT_UNKNOWN;
	public static String ERROR_TI_AGENT_INACTIVE;
	public static String ERROR_TI_AGENT_FILTERS;
	public static String ERROR_TI_AGENT_OPTIONS;
	public static String ERROR_TI_AGENT_PROJECT_NAME;
	
	
	public static String ERROR_TI_PROCESS_LAUNCH_ACTIVE;
	public static String ERROR_TI_PROCESS_LAUNCH_NO_APP;	
	public static String ERROR_TI_PROCESS_LAUNCH_INACTIVE_AG;
	public static String ERROR_TI_PROCESS_LAUNCH_TIMEOUT;	
	
	public static String ERROR_TI_CONFIGURATION_RESET;
	
	public static String ERROR_RUN_GC;
	
	public static String TI_AGNET_CONNECTION_SUCCESS;
	
	public static String TASK_CONNECTING_TO_AC;
	public static String TASK_LAUNCHING_PROCESS;
	public static String TASK_CONNECTING_TO_AGENT;
	
	public static String EXEC_LEVEL_OF_DETAIL;
	public static String EXEC_TYPE_OF_DATA;
	public static String EXEC_COLLECT_CPU_TIME;
	public static String EXEC_COLLECT_OBJECT_ALLOCATION;
	public static String EXEC_COLLECT_STATISTICS;
	public static String EXEC_COLLECT_FLOW;
	public static String EXEC_CONTENTION_ANALYSIS;
	
	public static String PROFILER_MEM_WARNING_TITLE;
	public static String PROFILER_MEM_WARNING_MSG;

	
	static 
	{
		NLS.initializeMessages(BUNDLE_NAME, TIMessages.class);
	}
}
