/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: DLocated.java,v 1.3 2008-05-23 14:11:50 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/


/*
 * Created on 26 juin 2003
 *
 */
package org.eclipse.tptp.platform.report.chart.internal;

/**
 * Location id.
 * 
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 * 
 */
public class DLocated
{
  /** in the area of the whole graphic (no more precise location found) (item is the DGraphic)*/
  public static final String InGraphicArea = "InGraphicArea";
  /** on the area where the title of graphic is rendered (item is the DGraphic) */
  public static final String InGraphicTitleArea = "InGraphicTitleArea";
  /** on the title text of the graphic (item is the DGraphic) */
  public static final String InGraphicTitleText = "InGraphicTitleText";
  
  /** on the title text of an Y axis (item is the located DAxis)*/
  public static final String InAxisYTitle = "InAxisYTitle";
  /** on the unit text of an Y axis (item is the located DAxis)*/
  public static final String InAxisYUnit = "InAxisYUnit";
  /** on the area of an Y axis (item is the located DAxis)*/
  public static final String InAxisYArea = "InAxisYArea";
  /** on the text of a unit along an Y axis (item is the located DAxis)*/
  public static final String InAxisYStepUnitText = "InAxisYStepUnitText";
  /** on the dot near a text of a unit along an Y axis (item is the located DAxis)*/
  public static final String InAxisYStepUnitTextDot = "InAxisYStepUnitTextDot";
  /** on one of step line of an Y axis (item is the located DAxis)*/
  public static final String InAxisYStepLine = "InAxisYStepLine";
  /** on one of step dot of an Y axis (item is the located DAxis)*/  
  public static final String InAxisYStepDot  = "InAxisYStepDot";
  /** on the main line of an Y axis (item is the located DAxis)*/
  public static final String InAxisYLine = "InAxisYLine";
  
  /** on the title text of an X axis (item is the located DAxis)*/
  public static final String InAxisXTitle = "InAxisXTitle";
  /** on the unit text of an X axis (item is the located DAxis)*/
  public static final String InAxisXUnit = "InAxisXUnit";
  /** on the area of an X axis (item is the located DAxis)*/
  public static final String InAxisXArea = "InAxisXArea";
  /** on the text of a unit along an X axis (item is the located DAxis)*/
  public static final String InAxisXStepUnitText = "InAxisXStepUnitText";
  /** on the dot near a text of a unit along an X axis (item is the located DAxis)*/
  public static final String InAxisXStepUnitTextDot = "InAxisXStepUnitTextDot";
  /** on one of step line of an X axis (item is the located DAxis)*/
  public static final String InAxisXStepLine = "InAxisXStepLine";
    /** on one of step dot of an X axis (item is the located DAxis)*/  
  public static final String InAxisXStepDot = "InAxisXStepDot";
  /** on the main line of an X axis (item is the located DAxis)*/
  public static final String InAxisXLine = "InAxisXLine";

  /** on the title text of an Z axis (item is the located DAxis)*/
  public static final String InAxisZTitle = "InAxisZTitle";
  /** on the text of a unit along an Z axis (item is the located DAxis)*/
  public static final String InAxisZStepUnitText = "InAxisZStepUnitText";

  /** on a bar (rectangle) corresponding to a DPoint */
  public static final String CurveBar = "CurveBar";
  /** on a text defined by a DPoint (see also LabelText) */
  public static final String CurvePointText = "CurvePointText";
  /** on a sector defined by a DPoint */
  public static final String CurveSector = "CurveSector";
  /** near a segment of a curve */
  public static final String CurveLine = "CurveLine";
  /** on a point of a curve point */
  public static final String CurvePoint = "CurvePoint";
  /** in legend color's rectangle (item is DCurve) */
  public static final String LegendColor = "LegendColor";
  /** in legend text (item is DCurve) */
  public static final String LegendText = "LegendText";
  /** in legend area, not on a particular legend entry (item==null) */
  public static final String LegendArea = "LegendArea";
  /** on the text of a lable, assicated item is the DText defining the label */
  public static final String LabelText = "LabelText";
  /** near a maker line of an axis */
  public static final String MarkerLine = "MarkerLine";
}
