/* ***********************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ISVGCircleBase.java,v 1.1 2005-03-30 08:26:38 dguilbaud Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

package org.eclipse.tptp.platform.report.chart.svg.internal.generator;
/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ISVGCircleBase.java,v 1.1 2005-03-30 08:26:38 dguilbaud Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * <code>ISVGCircleBase</code> interface defines accessors for attributes which are 
 * common to Scalable Vector Graphics (SVG) "circle" elements. Also provides for
 * generating the implementation element.
 * 

 * $Revision: 1.1 $
 */
public interface ISVGCircleBase {

	/**
	 * Generates and returns the implementation of the SVG element.
	 * 
	 * @param Document the target SVG document.	
	 * @return Element the implementation element
	 * @throws DOMException if the tag name contains an illegal character.	
	 */
	Element doImplementation(Document svgDocument) throws DOMException;	
	
	/**
	 * Returns the cx.
	 * @return String
	 */
	String getCx();
	
	/**
	 * Returns the cy.
	 * @return String
	 */
	String getCy();

	/**
	 * Returns the radius.
	 * @return String
	 */
	String getRadius();

	/**
	 * Sets the cx.
	 * @param cx The cx to set
	 */
	void setCx(String cx);

	/**
	 * Sets the cy.
	 * @param cy The cy to set
	 */
	void setCy(String cy);

	/**
	 * Sets the radius.
	 * @param radius The radius to set
	 */
	void setRadius(String radius);
}


