/* ***********************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: TitleBar.java,v 1.1 2005-03-30 08:26:42 dguilbaud Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: TitleBar.java,v 1.1 2005-03-30 08:26:42 dguilbaud Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.tptp.platform.report.chart.svg.internal.input;

import org.w3c.dom.Element;

import java.util.List;



/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Title Bar</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.TitleBar#getLabel <em>Label</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.TitleBar#isWithSeparator <em>With Separator</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.TitleBar#getAccessibility <em>Accessibility</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.TitleBar#getEventHandler <em>Event Handler</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.TitleBar#getTooltip <em>Tooltip</em>}</li>
 * </ul>
 * </p>
 *
 * @model 
 * @generated
 */
public interface TitleBar {
	/**
	 * Returns the value of the '<em><b>Background Color</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Background Color</em>' attribute.
	 * @see #setBackgroundColor(String)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getTitleBar_BackgroundColor()
	 * @model 
	 * @generated
	 */
	String getBackgroundColor();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.TitleBar#getBackgroundColor <em>Background Color</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Background Color</em>' attribute.
	 * @see #getBackgroundColor()
	 * @generated
	 */
	void setBackgroundColor(String value);

	/**
	 * Returns the value of the '<em><b>Label</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Label</em>' attribute.
	 * @see #setLabel(String)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getTitleBar_Label()
	 * @model 
	 * @generated
	 */
	String getLabel();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.TitleBar#getLabel <em>Label</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Label</em>' attribute.
	 * @see #getLabel()
	 * @generated
	 */
	void setLabel(String value);

	/**
	 * Returns the value of the '<em><b>Show</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Show</em>' attribute.
	 * @see #isSetShow()
	 * @see #unsetShow()
	 * @see #setShow(boolean)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getTitleBar_Show()
	 * @model default="true" unsettable="true"
	 * @generated
	 */
	boolean isShow();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.TitleBar#isShow <em>Show</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Show</em>' attribute.
	 * @see #isSetShow()
	 * @see #unsetShow()
	 * @see #isShow()
	 * @generated
	 */
	void setShow(boolean value);

	/**
	 * Unsets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.TitleBar#isShow <em>Show</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetShow()
	 * @see #isShow()
	 * @see #setShow(boolean)
	 * @generated
	 */
	void unsetShow();

	/**
	 * Returns whether the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.TitleBar#isShow <em>Show</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>Show</em>' attribute is set.
	 * @see #unsetShow()
	 * @see #isShow()
	 * @see #setShow(boolean)
	 * @generated
	 */
	boolean isSetShow();

	/**
	 * Returns the value of the '<em><b>With Separator</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>With Separator</em>' attribute.
	 * @see #isSetWithSeparator()
	 * @see #unsetWithSeparator()
	 * @see #setWithSeparator(boolean)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getTitleBar_WithSeparator()
	 * @model default="true" unsettable="true"
	 * @generated
	 */
	boolean isWithSeparator();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.TitleBar#isWithSeparator <em>With Separator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>With Separator</em>' attribute.
	 * @see #isSetWithSeparator()
	 * @see #unsetWithSeparator()
	 * @see #isWithSeparator()
	 * @generated
	 */
	void setWithSeparator(boolean value);

	/**
	 * Unsets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.TitleBar#isWithSeparator <em>With Separator</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isSetWithSeparator()
	 * @see #isWithSeparator()
	 * @see #setWithSeparator(boolean)
	 * @generated
	 */
	void unsetWithSeparator();

	/**
	 * Returns whether the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.TitleBar#isWithSeparator <em>With Separator</em>}' attribute is set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return whether the value of the '<em>With Separator</em>' attribute is set.
	 * @see #unsetWithSeparator()
	 * @see #isWithSeparator()
	 * @see #setWithSeparator(boolean)
	 * @generated
	 */
	boolean isSetWithSeparator();

	/**
	 * Returns the value of the '<em><b>Accessibility</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Accessibility</em>' containment reference.
	 * @see #setAccessibility(Accessibility)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getTitleBar_Accessibility()
	 * @model containment="true"
	 * @generated
	 */
	Accessibility getAccessibility();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.TitleBar#getAccessibility <em>Accessibility</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Accessibility</em>' containment reference.
	 * @see #getAccessibility()
	 * @generated
	 */
	void setAccessibility(Accessibility value);

	/**
	 * Returns the value of the '<em><b>Event Handler</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.tptp.platform.report.chart.svg.internal.input.EventHandler}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Event Handler</em>' containment reference list.
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getTitleBar_EventHandler()
	 * @model type="org.eclipse.tptp.platform.report.chart.svg.internal.input.EventHandler" containment="true"
	 * @generated
	 */
	List getEventHandler();

	/**
	 * Returns the value of the '<em><b>Tooltip</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Tooltip</em>' containment reference.
	 * @see #setTooltip(Tooltip)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.input.InputPackage#getTitleBar_Tooltip()
	 * @model containment="true"
	 * @generated
	 */
	Tooltip getTooltip();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.input.TitleBar#getTooltip <em>Tooltip</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Tooltip</em>' containment reference.
	 * @see #getTooltip()
	 * @generated
	 */
	void setTooltip(Tooltip value);

	/**
	 * Returns the document object element of this object. 
	 * If this object was not initialized with an element, null will be returned.
	 * @return the element in the DOM represented by this object
	 */
	public Element getElement(); 

} // TitleBar
