/* ***********************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ColorPaletteSets.java,v 1.1 2005-03-30 08:26:51 dguilbaud Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ColorPaletteSets.java,v 1.1 2005-03-30 08:26:51 dguilbaud Exp $
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.tptp.platform.report.chart.svg.internal.palettes;

import java.util.List;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Color Palette Sets</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.palettes.ColorPaletteSets#getResourceBundle <em>Resource Bundle</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.palettes.ColorPaletteSets#getColorPaletteSet <em>Color Palette Set</em>}</li>
 *   <li>{@link org.eclipse.tptp.platform.report.chart.svg.internal.palettes.ColorPaletteSets#getDefaultSetId <em>Default Set Id</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.tptp.platform.report.chart.svg.internal.palettes.PalettesPackage#getColorPaletteSets()
 * @model 
 * @generated
 */
public interface ColorPaletteSets {
	/**
	 * Returns the value of the '<em><b>Resource Bundle</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Resource Bundle</em>' attribute.
	 * @see #setResourceBundle(String)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.palettes.PalettesPackage#getColorPaletteSets_ResourceBundle()
	 * @model 
	 * @generated
	 */
	String getResourceBundle();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.palettes.ColorPaletteSets#getResourceBundle <em>Resource Bundle</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Resource Bundle</em>' attribute.
	 * @see #getResourceBundle()
	 * @generated
	 */
	void setResourceBundle(String value);

	/**
	 * Returns the value of the '<em><b>Color Palette Set</b></em>' containment reference list.
	 * The list contents are of type {@link org.eclipse.tptp.platform.report.chart.svg.internal.palettes.PaletteSetType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Color Palette Set</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Color Palette Set</em>' containment reference list.
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.palettes.PalettesPackage#getColorPaletteSets_ColorPaletteSet()
	 * @model type="org.eclipse.tptp.platform.report.chart.svg.internal.palettes.PaletteSetType" containment="true" required="true"
	 * @generated
	 */
	List getColorPaletteSet();

	/**
	 * Returns the value of the '<em><b>Default Set Id</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Default Set Id</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Default Set Id</em>' reference.
	 * @see #setDefaultSetId(EObject)
	 * @see org.eclipse.tptp.platform.report.chart.svg.internal.palettes.PalettesPackage#getColorPaletteSets_DefaultSetId()
	 * @model required="true"
	 * @generated
	 */
	Object getDefaultSetId();

	/**
	 * Sets the value of the '{@link org.eclipse.tptp.platform.report.chart.svg.internal.palettes.ColorPaletteSets#getDefaultSetId <em>Default Set Id</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Default Set Id</em>' reference.
	 * @see #getDefaultSetId()
	 * @generated
	 */
	void setDefaultSetId(Object value);

} // ColorPaletteSets
