/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: DAccessibilityTitle.java,v 1.2 2008-05-23 14:11:47 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/


package org.eclipse.tptp.platform.report.core.internal;

/**
 * This object can be added to IDItem to set a accessibility title
 * to provide information to the Screen Reader.
 * The idtems are DAxis, DCurve and DPoint.
 *  This feature is activated only for the SVG generation
 *  
 *  @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 *  
 */
public class DAccessibilityTitle extends DItem {
    
    private String text;
    
    /** creates an accessibility whit null title */
    public DAccessibilityTitle()
    {}
    
    /** creates an accessibility object by init title */
    public DAccessibilityTitle(String t)
    {
        text = t;
    }

    public String getText() {
        return text;
    }
    public void setText(String text) {
        this.text = text;
    }
}