/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: DShapes.java,v 1.2 2008-05-23 14:11:48 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/


package org.eclipse.tptp.platform.report.core.internal;

/**
 * This class provides the information to draw shape for the point
 * in a chart.
 * @see DGraphic
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 * 
 */
public class DShapes extends DItem {
    
    private String location;
    private boolean show = true;

    
    /** @return the shapes location */
    public String getLocation() {
        return location;
    }
    
    /** sets the shapes location */
    public void setLocation(String location) {
        this.location = location;
    }
    
    /** @return true if the shapes should be displayed */
    public boolean isShow() {
        return show;
    }
    
    /** sets if the shapes are displayed or not in the chart */
    public void setShow(boolean show) {
        this.show = show;
    }
}
