/* ***********************************************************
 * Copyright (c) 2005, 2008 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: Point.java,v 1.2 2008-05-23 14:11:54 jcayne Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 ************************************************************/

package org.eclipse.tptp.platform.report.igc.util.internal;

import org.eclipse.tptp.platform.report.igc.internal.IPoint;

/** 
 * Simple implementation of an IPoint
 * 
 * @deprecated As of TPTP 4.5.0, use the TPTP Business Intelligence and Reporting Tools (BIRT) reporting infrastructure (<code>org.eclipse.tptp.platform.report.birt</code>).
 * 
 */
public class Point implements IPoint 
{
  protected int x_,y_;
  public Point() {}
  public Point(int x, int y) { x_=x; y_=y; }
  public int getX() { return x_; }
  public int getY() { return y_; }
  public void setX( int x ) { x_=x; }
  public void setY( int y ) { y_=y; }
  
  public void setPoint( int x, int y ) { x_=x; y_=y; }
  public void setPoint( IPoint p ) { x_=p.getX(); y_=p.getY(); }
  
  public void translate( int x, int y ) { x_+=x; y_+=y; }
  public void translate( IPoint p ) { x_+=p.getX(); y_+=p.getY(); }
  
  public String toString()
  {
    return super.toString()+"{"+x_+","+y_+"}";
  }
}
