/**********************************************************************
 * Copyright (c) 2011 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: 
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/

package org.eclipse.tptp.trace.jvmti.internal.client.views;

import java.util.ArrayList;

import org.eclipse.hyades.trace.views.util.internal.ColumnData;
import org.eclipse.hyades.trace.views.util.internal.ColumnsDialog;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Shell;

// TIColumnsDialogs extends ColumnsDialog so that when 
// restore defaults are pressed, the columns would be in
// TIColumnData and not ColumnData
// fixes Defect 84634
public class TIColumnsDialog extends ColumnsDialog {

	public TIColumnsDialog(Shell shell, String windowTitle, Image windowImage,
			ArrayList data, String defaultColumnsTemplate,
			String contextHelpId, String context) {
		super(shell, windowTitle, windowImage, data, defaultColumnsTemplate,
				contextHelpId, context);
		// TODO Auto-generated constructor stub
	}
	
	protected void buttonPressed(int buttonId) {
		if (buttonId == _restoreDefaultsButtonId) {
			_data.clear();
			_data.addAll(ColumnData.createColumnDataFromString(_defaultColumnsTemplate));
			_data = TIColumnData.convertColumnData(_data);
			for (int idx = 0; idx < _data.size(); idx++) {
				TIColumnData data = (TIColumnData) _data.get(idx);
				data.setContext(_context);
			}
			
			populateList();
		}
		else {
			super.buttonPressed(buttonId);
		}
	}

}
