/*******************************************************************************
 * Copyright (c) 2005, 2006 Intel Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Guru Nagarajan,Intel - Initial API and implementation
 *
 * $Id$ 
 *******************************************************************************/ 


package org.eclipse.tptp.platform.execution.util.internal;


public class TPTPBinaryArray {

	protected byte[] _data;
	protected int _padding=0;

public TPTPBinaryArray() {
	super();
}

public TPTPBinaryArray(byte[] data) {
	if(data!=null) {
		_data=data;
		calculatePadding();
	}
	else {
		_padding=0;
	}
}

private void calculatePadding() {
	_padding=4-_data.length%4;
	if(_padding==4) {
		_padding=0;
	}
}

public byte[] getData() {
	return _data;
}

public int getPadding() {
	return _padding;
}

public int getSize() {
	return _data.length+_padding;
}

public long length() {
	if(_data!=null)
		return _data.length;

	return 0;
}

public void setData(byte[] data) {
	_data=data;
	calculatePadding();
}

public void setData(byte[] data, int offset, int length) {
	if(data!=null) {
		_data=new byte[length];
		System.arraycopy(data, offset, _data, 0, length);
		calculatePadding();
	}
}

}